main()
{
	//elevator script fixed by: andy jensen	(and Robbo!)
	maps\mp\_load::main();

	//setExpFog(900, 1400, 0.5, 0.5, 0.5, 0);
	//VisionSetNaked( "mp_cargoship" );
	ambientPlay("ambient_crash");

	game["allies"] = "marines";
	game["axis"] = "opfor";
	game["attackers"] = "axis";
	game["defenders"] = "allies";
	game["allies_soldiertype"] = "desert";
	game["axis_soldiertype"] = "desert";

	setdvar( "r_specularcolorscale", "1" );

	setdvar("r_glowbloomintensity0",".25");
	setdvar("r_glowbloomintensity1",".25");
	setdvar("r_glowskybleedintensity0",".3");
	setdvar("compassmaxrange","6000");

	level.elevatorDown = true; // elevator starts at bottom: true/false
	level.elevatorMoving = false; // elevator is not currently moving
    level._effect[ "redflash" ]			= loadfx( "misc/lift_light_red" );
    level._effect[ "redstatic" ]		= loadfx( "misc/lift_light" );
    level._effect[ "greenstatic" ]		= loadfx( "misc/lift_light_green" );


    level.showgreen = true;
    level.redflash = false;
    level.redstatic = false;
    

	thread elevator_start();
    thread sidelines();
    thread heli_setup();
}


elevator_start() 
{
wait 5;
level.elevLight = getentarray ("redlightb","targetname");
elevator = getentarray ("elevatorswitch","targetname");

toprightdoor = getent ("trightdoor","targetname");
topleftdoor = getent ("tleftdoor","targetname");
toprightdoor movex(-31,0.05);
topleftdoor moveX(31,0.05);

rightgate = getent ("rightdoor", "targetname"); 
leftgate = getent ("leftdoor", "targetname"); 
//rightgate enablelinkto();
//leftgate enablelinkto();

if ( isdefined(elevator) )
for (i = 0; i < elevator.size; i++) {
elevator[i] thread elevator_think();

}

for(i=0; i<level.elevLight.size; i++)
{
    level.elevLight[i] thread flash_red();
    level.elevLight[i] thread staticRed();
    level.elevLight[i] thread staticGreen();
}
}

elevator_think() 
{

while (1) 
{
self waittill ("trigger");
if (!level.elevatorMoving)
thread elevator_move();
}
}


elevator_move() 
{
elevatormodel = getent ("elevatormodel", "targetname");

// this is a script_brushmodel, just like the elevator you already have - it has a targetname of elevatorgate place it 100 units up from the floor of your elevator
rightgate = getent ("rightdoor", "targetname"); 
leftgate = getent ("leftdoor", "targetname"); 
topblock = getent ("topblock","targetname");
bottomblock = getent ("bottomblock","targetname");

toprightdoor = getent ("trightdoor","targetname");
topleftdoor = getent ("tleftdoor","targetname");
bottomrightdoor = getent ("brightdoor","targetname");
bottomleftdoor = getent ("bleftdoor","targetname");

topgauge = getent ("topgauge","targetname");
bottomgauge = getent ("bottomgauge","targetname");


level.showgreen = false;
level.redflash = true;

level.elevatorMoving = true;
hide_trigs();
speed = 6;
height = 480;
wait (0.5);
if (level.elevatorDown) 
{ // moves to top
bottomblock moveZ(-100,0.2);

bottomblock waittill("movedone");

rightgate movex(-31,2,0.5,0.5);
leftgate moveX(31,2,0.5,0.5);
wait 0.5;

bottomrightdoor movex(-31,2,0.5,0.5);
bottomleftdoor moveX(31,2,0.5,0.5);

bottomleftdoor waittill("movedone"); // script waits until gate is closed
bottomblock moveZ(100,0.2);
wait (1); // short pause
level.redflash = false;
level.redstatic = true;

//elevatormodel playsound ("elevator1"); // sound definition for soundaliases.csv
wait (1); // wait a second to hear the motor start and then start the movement of the lift - feels more realistic
elevatormodel moveZ (height, speed, 1, 1);
rightgate  moveZ (height, speed, 1, 1);
leftgate moveZ (height, speed, 1, 1);
topgauge moveZ (14, speed);
bottomgauge moveZ (14, speed);
elevatormodel waittill ("movedone");

level.redstatic = false;
level.redflash = true;




wait (1); // short pause


toprightdoor movex(31,2,0.5,0.5);
topleftdoor moveX(-31,2,0.5,0.5); // This moves the door/gate brushmodel up 100 units, opening the entrance.
wait 0.5;
rightgate movex(31,2,0.5,0.5);
leftgate moveX(-31,2,0.5,0.5);
leftgate waittill("movedone");

level.elevatorDown = false;



}


else { // moves to bottom
topblock moveZ(-100,0.2);

topblock waittill("movedone");
rightgate movex(-31,2,0.5,0.5);
leftgate moveX(31,2,0.5,0.5);
wait 0.5;

toprightdoor movex(-31,2,0.5,0.5);
topleftdoor moveX(31,2,0.5,0.5);

leftgate waittill("movedone");
topleftdoor waittill("movedone");
topblock moveZ(100,0.2);
level.redflash = false;
level.redstatic = true;
wait (1); 


//elevatormodel playsound ("elevator1"); // sound definition for soundaliases.csv
wait (1);  // wait a second to hear the motor start and then start the movement of the lift - feels more realistic
elevatormodel moveZ (height - (height * 2), speed, 1, 1);
rightgate  moveZ (height - (height * 2), speed, 1, 1);
leftgate moveZ (height - (height * 2), speed, 1, 1);
topgauge moveZ (-14, speed);
bottomgauge moveZ (-14, speed);
elevatormodel waittill ("movedone");

level.redstatic = false;
level.redflash = true;


wait (1); 
bottomrightdoor movex(31,2,0.5,0.5);
bottomleftdoor moveX(-31,2,0.5,0.5); // This moves the door/gate brushmodel up 100 units, opening the entrance.
wait 0.5;
rightgate movex(31,2,0.5,0.5);
leftgate moveX(-31,2,0.5,0.5);
leftgate waittill("movedone");

level.elevatorDown = true;
}
level.redflash = false;
wait 0.5;
level.showgreen = true;

level.elevatorMoving = false;
show_trigs();
}

hide_trigs()
{
switches = getentarray ("elevatorswitch","targetname");

for(i=0; i<switches.size; i++) switches[i] maps\mp\_utility::triggerOff();

}

show_trigs()
{
switches = getentarray ("elevatorswitch","targetname");

for(i=0; i<switches.size; i++) switches[i] maps\mp\_utility::triggerOn();

}

flash_red()
{
      while(1)
      {
             while(level.redflash)
             {
                    PlayFX( level._effect[ "redflash" ], self.origin );
                    wait 0.5;
             }
             wait 0.05;
      }
}

staticRed()
{
      while(1)
      {
              while(level.redstatic)
              {
                      PlayFX( level._effect[ "redstatic" ], self.origin );
                      wait 0.1;
              }
              wait 0.05;
      }
}

staticGreen()
{
      while(1)
      {
              while(level.showgreen)
              {
                      PlayFX( level._effect[ "greenstatic" ], self.origin );
                      wait 0.1;
              }
              wait 0.05;
      }
}


sidelines()
{
lines = getent("sidelines","targetname");
while(1)
{
lines waittill("trigger",player);
if(!isdefined(player.isinTrigger)) player.isinTrigger = false;
if(player.isinTrigger == false)
{
iprintln(player.name + " ^2Touched a Sideline!");
player thread timer();
player.isinTrigger = true;
}
wait 0.05;
}
}

timer()
{
wait 5;
self.isinTrigger = false;

}

heli_setup()
{

PreCacheModel( "vehicle_cobra_helicopter_fly_low" );
PreCacheModel( "vehicle_cobra_helicopter_fly" );

level waittill("connecting", player);

//owner = spawn("player", (0,0,0));
//players = getentarray("player","classname");
      wait 0.05;

      owner = player;
      
    
      chopper = spawn_helicopter(owner, (0,0,0), (0,0,0), "cobra_mp", "vehicle_cobra_helicopter_fly" );
          chopper hide();


wait 2;
chopper thread heli_loop();
chopper heli_start();
}

heli_start()
{

      level.startpoint_ar = getentarray("map_heli_start","targetname");

if( !isdefined( level.startpoint_ar )) {
    iprintln("No start points available");
    return;
}

level.startpoint = level.startpoint_ar[ (randomint(level.startpoint_ar.size)) ];
//self.origin = level.startpoint.origin;
//iprintln("Chopper approaching!");
			heli_speed = 200;
			heli_accel = 70;
self setspeed( heli_speed, heli_accel );	
			self setvehgoalpos( level.startpoint.origin, 1 );
            self setgoalyaw( level.startpoint.angles[1] );

			self waittillmatch( "goal" );

        self show();
		self playLoopSound( "mp_cobra_helicopter" );
      	self.currentstate = "ok";
	    self.laststate = "ok";
	    self setdamagestage( 3 );

self heli_fly();

}
spawn_helicopter( owner, origin, angles, model, targetname )
{
	chopper = spawnHelicopter( owner, origin, angles, model, targetname );
	
	return chopper;
}

heli_fly()
{
self endon("heli_left");
//startpoint = getent("map_heli_start","targetname");
// init vars
level.stop_next_point = false;
level.heli_gone_to_center = false;
level.center_loopcount = 0;
level.heli_loopcount = 0;
pos = self.origin;

self.targetpoint = getent(level.startpoint.target,"targetname");

if( !isdefined( self.targetpoint )) {
    iprintln("No target node");
    return;
}

	wait( 2 );
               
			heli_speed = 30+randomInt(20);
			heli_accel = 15+randomInt(15);

			self setspeed( heli_speed, heli_accel );	
			self setvehgoalpos( (self.origin +(0,0,self.targetpoint.origin[2])), 0 );
            self setgoalyaw( level.startpoint.angles[1] );

			self waittillmatch( "goal" );

			self setvehgoalpos( (self.targetpoint.origin +(0,0,30)), 0 );
            self setgoalyaw( self.targetpoint.angles[1] );
            self waittillmatch( "goal" );

          cur_point = self.targetpoint; 

          first_dest_point =  self.targetpoint;

          self thread fly_center();
          self thread heli_leave();
          while(1)
          {
                  heli_speed = 30+randomInt(20);
			      heli_accel = 15+randomInt(15);

			      self setspeed( heli_speed, heli_accel );

                  stop = 0; 
                  temp_wait_time = 0;
                  self.next_target = cur_point.target;
                  self.targetpoint = getent(self.next_target,"targetname");
                  if( !isdefined( self.targetpoint )) {
                      iprintln("No target point");
                      return;
                  }
                            chance = randomint(7);
                           // iprintln(chance);
                            if(((chance==0)||(level.stop_next_point))&& level.heli_loopcount>0) {
                                      //  iprintln("stopping");                                   
                                        self setgoalyaw( self.targetpoint.angles[1] );
                                        stop = 1; 
                                        temp_wait_time = (randomint(15)+2);
                                        level.stop_next_point = false;

                                        if((level.heli_loopcount > 4 ))
                                        {                   
                                     //          iprintln("leaving");
                                               self notify ("heli_leave");
                                        }
                            }

                  self setvehgoalpos( (self.targetpoint.origin +(0,0,30)),stop);

                  self waittillmatch( "goal" );
                  wait temp_wait_time;
                  self notify ("moving_on");
                  self waittill("next_node");

                  if(self.targetpoint == first_dest_point) level.heli_loopcount++;
                  cur_point = self.targetpoint; 
          }
}

heli_loop()
{
while(1)
{
self waittill("heli_left");

wait (randomint(75)+140);

heli_start();

}

}

fly_center()
{
self endon("heli_leave");
center_point = getent("map_heli_center","targetname");
                  if( !isdefined( center_point )) {
                      iprintln("No center point");
                      return;
                  }
while(1)
{
self waittill( "moving_on" );

chance = randomint(9);

//iprintln(chance);
if(chance==0 && level.heli_loopcount>0 && !level.heli_gone_to_center )
{
//iprintln("going to center");
level.stop_next_point = true;
heli_speed = 30+randomInt(20);
heli_accel = 15+randomInt(15);
self setspeed( heli_speed, heli_accel );	
self setvehgoalpos( (center_point.origin +(0,0,30)), 1 );

self waittill( "goal" );

self thread center_spin();

wait (randomint(20) + 6);

self notify("next_node");
level.heli_gone_to_center = true;
level.center_loopcount = level.heli_loopcount;
level.heli_loopcount = 3;
}
else self notify("next_node");

}
}

center_spin()
{
self endon("heli_leave");
self endon ("next_node");
start = self.angles[1];
dir = randomint(2);
i=0;
if(dir==0)
{

          while(1)
          {
        //  iprintln("spinning");
               if(i>358) i=0;
               self setgoalyaw( start + i );          
               i++;                
               wait 0.05;   
          }
}
else
{
          while(1)
          {
      //    iprintln("spinning");
               if(i>358) i=0;
               self setgoalyaw( start - i );
               i++;  
               wait 0.05;  
          }
}
}

heli_leave()
{
    self waittill ("heli_leave");
    self waittill ("moving_on");
    
        

	self notify( "desintation reached" );
	self notify( "leaving" );
	heli_leavepoints = getentarray("map_heli_leave","targetname");
	// helicopter leaves randomly towards one of the leave origins
	rand_leave_target = randomInt( heli_leavepoints.size );
	leave_target = heli_leavepoints[rand_leave_target];

    self setspeed( 100, 45 );

	self setvehgoalpos( self.origin + (0,0,420), 0 );
    self waittillmatch( "goal" );

//    wait 8;
//	heli_reset();
		
	self setvehgoalpos( leave_target.origin, 1 );
	self waittillmatch( "goal" );
    self notify("heli_left");
    self stoploopsound();
    self hide();
//	self notify( "death" );
	
//	level.chopper = undefined;	
//	self delete();
}



